import React from 'react';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
interface DraggableListItemProps extends BaseProps {
    readonly disabled?: boolean;
    readonly className?: string;
}
export declare const DraggableListItem: React.FC<DraggableListItemProps>;
/**
 * Draggable list
 *
 * A list where the items can be dragged through a drag handler
 * rendered on the right side of the list items.
 */
export interface DraggableListProps extends Omit<BaseProps, 'onChange'> {
    /**
     * Function called when list order changes with list of re-ordered indices as argument
     */
    readonly onChange: (indices: ReadonlyArray<number>) => void;
}
export declare const DraggableList: React.FC<DraggableListProps>;
export {};
