import React from 'react';
declare type BaseElement = HTMLInputElement;
declare type BaseProps = React.InputHTMLAttributes<BaseElement>;
export interface DroppableProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * Text that is shown inside the component.
     */
    readonly inputLabel: string;
    /**
     * A function which is run when the file is selected.
     */
    readonly onFileChange?: (file?: File) => void;
    /**
     * Text which can be used to inform user about supported formats.
     */
    readonly supportedFormats?: string;
    /**
     * Name of the selected file
     */
    readonly selectedFileName?: string;
}
export declare const Droppable: React.FC<DroppableProps>;
export {};
