import React, { Dispatch, SetStateAction } from 'react';
import { IconType } from '../Icon';
export interface ExpandableListItemType {
    readonly id: string;
    readonly label: string;
    readonly icon: IconType;
    readonly selected?: boolean;
    readonly onClick?: VoidFunction;
    readonly items?: ReadonlyArray<ExpandableListItemType>;
}
export declare const ExpandableListContainer: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {}, never>;
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
export interface ExpandableListItemProps extends BaseProps {
    readonly item: ExpandableListItemType;
    readonly expandedItems: ReadonlyArray<string>;
    readonly setExpandedItems: Dispatch<SetStateAction<ReadonlyArray<string>>>;
    readonly isNestedItem: boolean;
    readonly accordion?: boolean;
}
/**
 * ExpandableListItem
 *
 * The ExpandableListItem component (recursive component) wraps and builds the item in the list.
 * It may contain an array of nested items, each of which will be wrapped in this
 * component as well.
 *
 */
export declare const ExpandableListItem: React.VFC<ExpandableListItemProps>;
export {};
