import { MemoExoticComponent, FC, SVGProps } from 'react';
declare type BaseElement = HTMLSpanElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
export declare type IconType = MemoExoticComponent<FC<SVGProps<SVGSVGElement>>> | FC<SVGProps<SVGSVGElement>>;
export declare type IconSize = 'small' | 'medium' | 'large' | 'extraLarge';
export interface IconProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * The icon element.
     */
    readonly icon: IconType;
    /**
     * Changes the size of the Icons.
     */
    readonly size?: IconSize;
}
export declare const Icon: FC<IconProps>;
export declare const ClickableIcon: import("styled-components").StyledComponent<FC<IconProps>, import("styled-components").DefaultTheme, {
    tabIndex: 0;
}, "tabIndex">;
export {};
