"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RadioButton = RadioButton;
exports.RadioButtonAtom = void 0;
exports.RadioButtonGroup = RadioButtonGroup;
exports.RadioNative = exports.RadioContainer = exports.RadioButtonGroupField = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _utils = require("../utils");

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["label", "checked", "partial", "disabled", "error", "onChange", "onValueChange", "hovered", "onFocus", "onPointerUp", "onPointerDown"],
    _excluded2 = ["options", "name", "value", "onChange", "onValueChange", "error", "compact"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 *
 * The button part of the radio button
 *
 */
var AtomContainer = _styledComponents.default.div.withConfig({
  displayName: "RadioButton__AtomContainer",
  componentId: "sc-1m0c1id-0"
})(["position:relative;display:inline-flex;align-items:center;justify-content:center;background-color:transparent;border-radius:", ";"], _designparams.shape.radius.small);

var SvgHalo = _styledComponents.default.div.withConfig({
  displayName: "RadioButton__SvgHalo",
  componentId: "sc-1m0c1id-1"
})(["position:absolute;top:2px;left:2px;height:20px;width:20px;border-radius:", ";transform-origin:center;transition:transform 100ms;"], _designparams.shape.radius.circle);

var SvgContainer = _styledComponents.default.svg.withConfig({
  displayName: "RadioButton__SvgContainer",
  componentId: "sc-1m0c1id-2"
})(["width:", ";height:", ";overflow:visible;position:absolute;top:0;fill:transparent;stroke:", ";"], _designparams.componentSize.mini, _designparams.componentSize.mini, _ref => {
  var {
    theme,
    checked,
    error
  } = _ref;
  return error ? theme.color.elementError() : checked ? theme.color.elementPrimary() : theme.color.element01();
});

var SvgRing = _styledComponents.default.circle.withConfig({
  displayName: "RadioButton__SvgRing",
  componentId: "sc-1m0c1id-3"
})(["stroke-width:2px;"]);

var SvgDot = _styledComponents.default.circle.withConfig({
  displayName: "RadioButton__SvgDot",
  componentId: "sc-1m0c1id-4"
})(["fill:", ";stroke:", ";"], _ref2 => {
  var {
    partial,
    theme
  } = _ref2;
  return partial ? theme.color.text05() : theme.color.elementPrimary();
}, _ref3 => {
  var {
    partial,
    theme
  } = _ref3;
  return partial ? theme.color.text05() : theme.color.elementPrimary();
});

var RadioButtonAtom = _ref4 => {
  var {
    checked,
    partial,
    error
  } = _ref4;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(AtomContainer, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(SvgHalo, {}), /*#__PURE__*/(0, _jsxRuntime.jsxs)(SvgContainer, {
      checked: checked,
      error: error.length > 0,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(SvgRing, {
        r: 9,
        cx: 12,
        cy: 12
      }), checked || partial ? /*#__PURE__*/(0, _jsxRuntime.jsx)(SvgDot, {
        r: 4.5,
        cx: 12,
        cy: 12,
        partial: !checked && partial
      }) : null]
    })]
  });
};
/**
 *
 * The label
 *
 */


exports.RadioButtonAtom = RadioButtonAtom;
var Label = (0, _styledComponents.default)(_Typography.Typography).withConfig({
  displayName: "RadioButton__Label",
  componentId: "sc-1m0c1id-5"
})(["display:flex;padding-top:3px;min-height:24px;height:fit-content;margin-left:", ";color:", ";white-space:initial;word-break:break-word;"], _designparams.spacing.medium, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.color.text01();
});
/**
 *
 * The input area which the user can interact with,
 * which spans the entire button + label area.
 *
 */

var RadioNative = _styledComponents.default.input.withConfig({
  displayName: "RadioButton__RadioNative",
  componentId: "sc-1m0c1id-6"
})(["display:unset;margin:0;padding:0;border:0;position:absolute;top:0;left:0;height:100%;width:100%;opacity:0;cursor:pointer;"]);
/**
 *
 * The container for the entire button + label,
 * with the input area as last child (catching events).
 *
 */


exports.RadioNative = RadioNative;

var RadioContainer = _styledComponents.default.div.withConfig({
  displayName: "RadioButton__RadioContainer",
  componentId: "sc-1m0c1id-7"
})(["position:relative;display:grid;grid-template-columns:24px auto;transition:transform 100ms;max-width:100%;&:hover ", "{background-color:", ";transform:scale(1.6);}", " &:focus-within{", "}&:active{", "{background-color:", ";transform:scale(1.7);}", "{stroke:", ";}", "{", "}}", ""], SvgHalo, _ref6 => {
  var {
    checked,
    theme
  } = _ref6;
  return checked ? theme.color.elementPrimary(_designparams.opacity[16]) : theme.color.element11(_designparams.opacity[16]);
}, _ref7 => {
  var {
    hovered,
    checked,
    theme
  } = _ref7;
  return hovered ? (0, _styledComponents.css)(["", "{background-color:", ";transform:scale(1.6);}"], SvgHalo, checked ? theme.color.elementPrimary(_designparams.opacity[16]) : theme.color.element11(_designparams.opacity[16])) : undefined;
}, _ref8 => {
  var {
    visibleFocus,
    checked,
    theme
  } = _ref8;
  return visibleFocus ? (0, _styledComponents.css)(["outline:none;", "{background-color:", ";transform:scale(1.6);}", "{outline:none;stroke:", ";}"], SvgHalo, checked ? theme.color.elementPrimary(_designparams.opacity[16]) : theme.color.element11(_designparams.opacity[16]), SvgRing, theme.color.textPrimary()) : undefined;
}, SvgHalo, _ref9 => {
  var {
    checked,
    theme
  } = _ref9;
  return checked ? theme.color.elementPrimary(_designparams.opacity[24]) : theme.color.element11(_designparams.opacity[24]);
}, SvgRing, _ref10 => {
  var {
    checked,
    theme
  } = _ref10;
  return checked ? theme.color.textPrimary() : theme.color.text02();
}, SvgDot, _ref11 => {
  var {
    partial,
    theme
  } = _ref11;
  return (0, _styledComponents.css)(["fill:", ";stroke:", ";"], partial ? theme.color.text02() : theme.color.textPrimary(), partial ? theme.color.text02() : theme.color.textPrimary());
}, _ref12 => {
  var {
    disabled
  } = _ref12;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
});

exports.RadioContainer = RadioContainer;

function RadioButton(_ref13) {
  var {
    label,
    checked,
    partial = false,
    disabled = false,
    error = '',
    onChange,
    onValueChange,
    hovered = false,
    onFocus,
    onPointerUp,
    onPointerDown
  } = _ref13,
      rest = _objectWithoutProperties(_ref13, _excluded);

  var ref = /*#__PURE__*/_react.default.createRef();

  var pressed = (0, _reactHooksShareable.usePressed)(ref);
  var handleChange = (0, _react.useCallback)(e => {
    onChange === null || onChange === void 0 ? void 0 : onChange(e);
    onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(e.target.value);
  }, [onChange, onValueChange]);
  var {
    isPointerOn,
    isPointerOff,
    determineVisibleFocus,
    visibleFocus
  } = (0, _reactHooksShareable.useVisibleFocus)();
  var handleFocus = (0, _react.useCallback)(e => {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
    determineVisibleFocus();
  }, [determineVisibleFocus, onFocus]);
  var handlePointerDown = (0, _react.useCallback)(e => {
    onPointerDown === null || onPointerDown === void 0 ? void 0 : onPointerDown(e);
    isPointerOn();
  }, [isPointerOn, onPointerDown]);
  var handlePointerUp = (0, _react.useCallback)(e => {
    onPointerUp === null || onPointerUp === void 0 ? void 0 : onPointerUp(e);
    isPointerOff();
  }, [isPointerOff, onPointerUp]);
  var radiobuttonLabel = (0, _react.useMemo)(() => {
    return label !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(Label, {
      variant: "navigation-label",
      children: label
    }) : null;
  }, [label]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(RadioContainer, {
    disabled: disabled,
    checked: checked,
    partial: partial,
    pressed: pressed,
    hovered: hovered,
    visibleFocus: visibleFocus,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(RadioButtonAtom, {
      checked: checked,
      partial: partial,
      error: error
    }), radiobuttonLabel, /*#__PURE__*/(0, _jsxRuntime.jsx)(RadioNative, _objectSpread({
      ref: ref,
      type: "radio",
      checked: checked,
      disabled: disabled,
      onPointerDown: handlePointerDown,
      onPointerUp: handlePointerUp,
      onFocus: handleFocus,
      onChange: handleChange
    }, rest))]
  });
}
/*
 * Radio Group
 */

/* stylelint-disable no-descending-specificity  */


var RadioButtonGroupContainer = _styledComponents.default.div.withConfig({
  displayName: "RadioButton__RadioButtonGroupContainer",
  componentId: "sc-1m0c1id-8"
})(["display:grid;grid-row-gap:", ";margin:", ";"], _ref14 => {
  var {
    compact
  } = _ref14;
  return !compact ? _designparams.spacing.large : _designparams.spacing.medium;
}, _ref15 => {
  var {
    compact
  } = _ref15;
  return !compact ? "".concat(_designparams.spacing.medium, " 0") : "".concat(_designparams.spacing.small, " 0");
});
/* stylelint-enable */


function RadioButtonGroup(_ref16) {
  var {
    options,
    name,
    value,
    onChange,
    onValueChange,
    error,
    compact: compactFromProps
  } = _ref16,
      rest = _objectWithoutProperties(_ref16, _excluded2);

  var {
    compact: compactFromTheme
  } = (0, _styledComponents.useTheme)();
  var compact = compactFromProps !== null && compactFromProps !== void 0 ? compactFromProps : compactFromTheme;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(RadioButtonGroupContainer, _objectSpread(_objectSpread({
    compact: compact
  }, rest), {}, {
    children: options.map((option, index) => /*#__PURE__*/(0, _jsxRuntime.jsx)(RadioButton, {
      name: name,
      value: option.value,
      label: option.label,
      disabled: option.disabled,
      checked: value === option.value,
      onChange: onChange,
      onValueChange: onValueChange,
      error: error
    }, index))
  }));
}

var RadioButtonGroupField = props => (0, _utils.withField)(RadioButtonGroup)(props);

exports.RadioButtonGroupField = RadioButtonGroupField;