"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SkeletonTableRows = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _Table = require("./Table");

var _context = require("./context");

var _TableCells = require("./TableCells");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["rows", "columns"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Skeleton rows (used as a loading indicator)
 */
var pulse = (0, _styledComponents.keyframes)(["from{opacity:1;}to{opacity:", ";}"], _designparams.opacity[48]); // hard-coded size for a checkbox skeleton

var SkeletonCheckboxContent = _styledComponents.default.div.withConfig({
  displayName: "SkeletonRows__SkeletonCheckboxContent",
  componentId: "sc-1qv1rzz-0"
})(["border:2px;width:18px;height:18px;"]); // generic skeleton to replace text


var SkeletonContent = _styledComponents.default.div.withConfig({
  displayName: "SkeletonRows__SkeletonContent",
  componentId: "sc-1qv1rzz-1"
})(["width:100%;height:", ";"], _designparams.spacing.large);

var SkeletonRowGrid = _styledComponents.default.div.withConfig({
  displayName: "SkeletonRows__SkeletonRowGrid",
  componentId: "sc-1qv1rzz-2"
})(["z-index:0;display:grid;position:relative;grid-template-rows:", ";outline:none;pointer-events:none;& ", ",& ", "{animation:", " 800ms infinite ease-in-out alternate;}&:nth-child(odd) ", ",&:nth-child(odd) ", "{background-color:", ";}&:nth-child(even) ", ",&:nth-child(even) ", "{background-color:", ";}"], _designparams.componentSize.extraLarge,
/*sc-selector*/
SkeletonContent,
/*sc-selector*/
SkeletonCheckboxContent, pulse,
/*sc-selector*/
SkeletonContent,
/*sc-selector*/
SkeletonCheckboxContent, _ref => {
  var {
    theme
  } = _ref;
  return theme.color.background01();
},
/*sc-selector*/
SkeletonContent,
/*sc-selector*/
SkeletonCheckboxContent, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.background02();
});

var SkeletonRow = /*#__PURE__*/_react.default.memo(_ref3 => {
  var {
    columns,
    gridTemplateColumns,
    hasCheckbox
  } = _ref3;
  var columnArray = Array.from(new Array(columns));
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(SkeletonRowGrid, {
    style: {
      gridTemplateColumns
    },
    children: [hasCheckbox ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_TableCells.TableCellCheckbox, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(SkeletonCheckboxContent, {})
    }) : null, columnArray.map((__, index) => /*#__PURE__*/(0, _jsxRuntime.jsx)(_TableCells.TableCellContent, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(SkeletonContent, {})
    }, index))]
  });
});

SkeletonRow.displayName = 'SkeletonRowComponent';

var SkeletonTableRows = /*#__PURE__*/_react.default.memo(_ref4 => {
  var {
    rows,
    columns
  } = _ref4,
      props = _objectWithoutProperties(_ref4, _excluded);

  var rowArray = Array.from(new Array(rows));
  var {
    onSelect
  } = (0, _react.useContext)(_context.TableContext);
  var {
    gridTemplateColumns
  } = (0, _Table.useGridTemplateColumns)();
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", _objectSpread(_objectSpread({
    style: {
      gridTemplateColumns
    }
  }, props), {}, {
    children: rowArray.map((_, i) => /*#__PURE__*/(0, _jsxRuntime.jsx)(SkeletonRow, {
      columns: columns,
      gridTemplateColumns: gridTemplateColumns,
      hasCheckbox: onSelect !== undefined
    }, i))
  }));
});

exports.SkeletonTableRows = SkeletonTableRows;
SkeletonTableRows.displayName = 'SkeletonTableRowsComponent';