"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createWarningToast = exports.createSuccessToast = exports.createProgressToast = exports.createLoadingToast = exports.createInfoToast = exports.createErrorToast = exports.createActionToast = exports.ToastMessage = exports.ToastLabel = exports.ToastIconWrapper = exports.ToastIconType = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _practicalReactComponentsIcons = require("practical-react-components-icons");

var _Link = require("../Link");

var _Icon = require("../Icon");

var _Typography = require("../Typography");

var _designparams = require("../designparams");

var _Spinner = require("../Spinner");

var _Progress = require("../Progress");

var _twoLinesClamp = require("../utils/twoLinesClamp");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["label", "message"],
    _excluded2 = ["label", "message"],
    _excluded3 = ["label", "message"],
    _excluded4 = ["label", "message"],
    _excluded5 = ["label", "message", "action"],
    _excluded6 = ["label", "message"],
    _excluded7 = ["label", "message", "progress"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var getIconColor = (theme, iconType) => {
  var {
    color
  } = theme;

  switch (iconType) {
    case ToastIconType.SUCCESS:
      return color.elementSuccess();

    case ToastIconType.WARNING:
      return color.elementWarning();

    case ToastIconType.ERROR:
      return color.elementError();

    case ToastIconType.ACTION:
      return color.elementPrimary();

    case ToastIconType.INFO:
    default:
      return color.text04();
  }
};

var ToastLabel = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "toastCreators__ToastLabel",
  componentId: "sc-128zro4-0"
})(["height:100%;", " ", " ", " ", ""], _twoLinesClamp.twoLinesClamp, _ref => {
  var {
    hasCloseButton
  } = _ref;
  return !hasCloseButton ? (0, _styledComponents.css)(["padding:0 ", ";"], _designparams.spacing.large) : (0, _styledComponents.css)(["padding-left:", ";"], _designparams.spacing.large);
}, _ref2 => {
  var {
    hasEmphasis: emphasis
  } = _ref2;
  return emphasis ? (0, _styledComponents.css)(["font-weight:", ";"], _ref3 => {
    var {
      theme
    } = _ref3;
    return theme.font.fontWeight.semibold;
  }) : undefined;
}, _ref4 => {
  var {
    isError
  } = _ref4;
  return isError ? (0, _styledComponents.css)(["color:", ";"], _ref5 => {
    var {
      theme
    } = _ref5;
    return theme.color.textError();
  }) : (0, _styledComponents.css)(["color:", ";"], _ref6 => {
    var {
      theme
    } = _ref6;
    return theme.color.text01();
  });
});
exports.ToastLabel = ToastLabel;
var ToastIconType;
exports.ToastIconType = ToastIconType;

(function (ToastIconType) {
  ToastIconType["SUCCESS"] = "success";
  ToastIconType["WARNING"] = "warning";
  ToastIconType["INFO"] = "info";
  ToastIconType["ERROR"] = "error";
  ToastIconType["ACTION"] = "action";
})(ToastIconType || (exports.ToastIconType = ToastIconType = {}));

var ToastIconWrapper = _styledComponents.default.div.withConfig({
  displayName: "toastCreators__ToastIconWrapper",
  componentId: "sc-128zro4-1"
})(["height:", ";width:", ";display:flex;align-items:center;justify-content:center;color:", ";"], _designparams.iconSize.medium, _designparams.iconSize.medium, _ref7 => {
  var {
    theme,
    iconType
  } = _ref7;
  return getIconColor(theme, iconType);
});

exports.ToastIconWrapper = ToastIconWrapper;
var ToastMessage = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "toastCreators__ToastMessage",
  componentId: "sc-128zro4-2"
})(["white-space:normal;"]);
exports.ToastMessage = ToastMessage;

/*
 * Success toast
 */
var createSuccessToast = _ref8 => {
  var {
    label,
    message
  } = _ref8,
      rest = _objectWithoutProperties(_ref8, _excluded);

  var labelComponent = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastLabel, {
    hasCloseButton: false,
    isError: false,
    hasEmphasis: message !== undefined,
    children: label
  });
  var icon = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastIconWrapper, {
    iconType: ToastIconType.SUCCESS,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.Icon, {
      icon: _practicalReactComponentsIcons.CheckIcon
    })
  });
  var messageComponent = message !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastMessage, {
    children: message
  }) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent,
    hasCloseButton: false
  }, rest);
};
/*
 * Error toast
 */


exports.createSuccessToast = createSuccessToast;

var createErrorToast = _ref9 => {
  var {
    label,
    message
  } = _ref9,
      rest = _objectWithoutProperties(_ref9, _excluded2);

  var labelComponent = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastLabel, {
    hasCloseButton: true,
    isError: true,
    hasEmphasis: message !== undefined,
    children: label
  });
  var icon = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastIconWrapper, {
    iconType: ToastIconType.ERROR,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.Icon, {
      icon: _practicalReactComponentsIcons.AlertIcon
    })
  });
  var messageComponent = message !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastMessage, {
    children: message
  }) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Warning toast
 */


exports.createErrorToast = createErrorToast;

var createWarningToast = _ref10 => {
  var {
    label,
    message
  } = _ref10,
      rest = _objectWithoutProperties(_ref10, _excluded3);

  var labelComponent = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastLabel, {
    hasCloseButton: true,
    isError: false,
    hasEmphasis: message !== undefined,
    children: label
  });
  var icon = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastIconWrapper, {
    iconType: ToastIconType.WARNING,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.Icon, {
      icon: _practicalReactComponentsIcons.WarningIcon
    })
  });
  var messageComponent = message !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastMessage, {
    children: message
  }) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Info toast
 */


exports.createWarningToast = createWarningToast;

var createInfoToast = _ref11 => {
  var {
    label,
    message
  } = _ref11,
      rest = _objectWithoutProperties(_ref11, _excluded4);

  var labelComponent = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastLabel, {
    hasCloseButton: true,
    isError: false,
    hasEmphasis: message !== undefined,
    children: label
  });
  var icon = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastIconWrapper, {
    iconType: ToastIconType.INFO,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.Icon, {
      icon: _practicalReactComponentsIcons.InfoIcon
    })
  });
  var messageComponent = message !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastMessage, {
    children: message
  }) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Action toast
 *
 * Has a custom action icon (primary color),
 * and a clickable action link.
 */


exports.createInfoToast = createInfoToast;
var LinkWrapper = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "toastCreators__LinkWrapper",
  componentId: "sc-128zro4-3"
})(["padding:0 ", ";font-weight:bold;"], _designparams.spacing.large);

var createActionToast = _ref12 => {
  var {
    label,
    message,
    action
  } = _ref12,
      rest = _objectWithoutProperties(_ref12, _excluded5);

  var labelComponent = /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(ToastLabel, {
      hasCloseButton: true,
      isError: false,
      hasEmphasis: false,
      children: label
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(LinkWrapper, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Link.Link, _objectSpread(_objectSpread({}, action.link), {}, {
        children: action.text
      }))
    })]
  });
  var icon = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastIconWrapper, {
    iconType: ToastIconType.ACTION,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.Icon, {
      icon: action.icon
    })
  });
  var messageComponent = message !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastMessage, {
    children: message
  }) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Loading toast
 */


exports.createActionToast = createActionToast;

var LoadingIconSize = _styledComponents.default.div.withConfig({
  displayName: "toastCreators__LoadingIconSize",
  componentId: "sc-128zro4-4"
})(["transform:scale(0.75);"]);

var createLoadingToast = _ref13 => {
  var {
    label,
    message
  } = _ref13,
      rest = _objectWithoutProperties(_ref13, _excluded6);

  var labelComponent = /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastLabel, {
    hasCloseButton: true,
    isError: false,
    hasEmphasis: message !== undefined,
    children: label
  });
  var icon = /*#__PURE__*/(0, _jsxRuntime.jsx)(LoadingIconSize, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Spinner.Spinner, {})
  });
  var messageComponent = message !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastMessage, {
    children: message
  }) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Progress toast
 */


exports.createLoadingToast = createLoadingToast;

var ProgressWrapper = _styledComponents.default.div.withConfig({
  displayName: "toastCreators__ProgressWrapper",
  componentId: "sc-128zro4-5"
})(["display:flex;align-items:center;padding-left:", ";"], _designparams.spacing.large);

var createProgressToast = _ref14 => {
  var {
    label,
    message,
    progress
  } = _ref14,
      rest = _objectWithoutProperties(_ref14, _excluded7);

  var labelComponent = /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(ToastLabel, {
      hasCloseButton: true,
      isError: false,
      hasEmphasis: message !== undefined,
      children: label
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(ProgressWrapper, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Progress.Progress, _objectSpread({}, progress))
    })]
  });
  var icon = /*#__PURE__*/(0, _jsxRuntime.jsx)(LoadingIconSize, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Spinner.Spinner, {})
  });
  var messageComponent = message !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastMessage, {
    children: message
  }) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};

exports.createProgressToast = createProgressToast;