"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ToggleButtonGroup = ToggleButtonGroup;
exports.ToggleButtonGroupWithField = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _utils = require("../utils");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["options", "onChange", "values", "exclusive"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ToggleButtonContainer = _styledComponents.default.div.withConfig({
  displayName: "ToggleButtonGroup__ToggleButtonContainer",
  componentId: "sc-1vdg6ui-0"
})(["box-sizing:border-box;max-width:100%;position:relative;cursor:pointer;transition:all 200ms;:not(:last-child){border-right:1px solid ", ";}", ""], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.element13();
}, _ref2 => {
  var {
    theme,
    selected,
    disabled
  } = _ref2;

  if (disabled) {
    return (0, _styledComponents.css)(["opacity:", ";pointer-events:none;cursor:default;box-shadow:none;"], _designparams.opacity[48]);
  }

  if (selected) {
    return (0, _styledComponents.css)(["&:active{z-index:1;box-shadow:-1px 0 0 5px ", ";border-radius:", ";}"], theme.color.elementPrimary(_designparams.opacity[24]), _designparams.shape.radius.medium);
  }
});

var ToggleButtonContent = _styledComponents.default.div.withConfig({
  displayName: "ToggleButtonGroup__ToggleButtonContent",
  componentId: "sc-1vdg6ui-1"
})(["background-color:", ";height:32px;width:100%;display:flex;align-items:center;justify-content:center;box-sizing:border-box;padding:0 ", ";overflow:hidden;white-space:nowrap;transition:all 200ms;", ""], _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.background00();
}, _designparams.spacing.medium, _ref4 => {
  var {
    theme,
    selected
  } = _ref4;

  if (selected) {
    return (0, _styledComponents.css)(["color:", ";fill:", ";background-color:", ";&:focus{outline-color:", ";}&:hover{background-color:", ";}"], theme.color.text00(), theme.color.text00(), theme.color.elementPrimary(), theme.color.textPrimary(), theme.color.textPrimary());
  }

  return (0, _styledComponents.css)(["&:hover{background-color:", ";}&:focus{background-color:", ";outline-color:", ";}&:active{background-color:", ";}color:", ";fill:", ";"], theme.color.element11(_designparams.opacity[16]), theme.color.element11(_designparams.opacity[16]), theme.color.textPrimary(), theme.color.element11(_designparams.opacity[24]), theme.color.element01(), theme.color.element01());
});

var ToggleButtonGrid = _styledComponents.default.div.withConfig({
  displayName: "ToggleButtonGroup__ToggleButtonGrid",
  componentId: "sc-1vdg6ui-2"
})(["width:100%;display:grid;grid-template-columns:repeat(auto-fit,minmax(", ",1fr));user-select:none;border:1px solid ", ";border-radius:", ";"], _designparams.componentSize.mini, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.color.element13();
}, _designparams.shape.radius.small);

/**
 * ToggleButton
 *
 * can be used to toggle between different states of the application.
 *
 * Usage of it can be found in e.g. DateTimePicker where it is used to
 * toggle between different time settings.
 */
function ToggleButton(_ref6) {
  var {
    id,
    values,
    disabled = false,
    onClick,
    content,
    exclusive = false
  } = _ref6;
  var selected = (0, _react.useMemo)(() => values.some(value => value === id), [values, id]);
  var onButtonClick = (0, _react.useCallback)(() => {
    if (disabled) {
      return;
    }

    if (exclusive && selected) {
      return;
    }

    onClick(id);
  }, [disabled, id, exclusive, selected, onClick]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(ToggleButtonContainer, {
    selected: selected,
    disabled: disabled,
    onClick: onButtonClick,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(ToggleButtonContent, {
      tabIndex: 1,
      selected: selected,
      children: content
    })
  });
}

function ToggleButtonGroup(_ref7) {
  var {
    options,
    onChange,
    values,
    exclusive = false
  } = _ref7,
      props = _objectWithoutProperties(_ref7, _excluded);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(ToggleButtonGrid, _objectSpread(_objectSpread({}, props), {}, {
    children: options.map(option => {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(ToggleButton, _objectSpread(_objectSpread({}, option), {}, {
        values: values,
        onClick: onChange,
        exclusive: exclusive
      }), option.id);
    })
  }));
}

var ToggleButtonGroupWithField = props => (0, _utils.withField)(ToggleButtonGroup)(props);

exports.ToggleButtonGroupWithField = ToggleButtonGroupWithField;